type grammar = grammar_item list

and grammar_item =
  GRule of string * tok
| GToken of string * string
| GPrec of (string * prec) list

and tok =
  TIdent of string
| TIgnore of tok
| TSeq of tok * tok
| TBranch of tok * tok
| TStar of tok
| TPlus of tok
| TOption of tok
| TLabeled of string * tok
| TSub of tok
| TPrec of string
| TBang of tok * tok

and prec =
  PLeft
| PRight
| PNonAssoc

exception Parse_error_string of string
